//title         : Arabic Letters
//description   : This script will fix the view of arabic letters that appear separated.
//author		: Ibrahim Elaraby (https://www.youtube.com/elnetaraby)
//date          : 2018-11-26
//version       : 1.0
//Attribution   : Omar Muhammad (http://omar84.com) developer "The Arabic Writer" God Bless Him.
//==================================================
! function () {
    var e = function () {
        var e = fl.getDocumentDOM();                
        if (!e) return void alert("No document opened.");
        var l = e.selection;                        
        if (l.length < 1 || l.length > 1) return void alert("You must select ONE Text-Line on the stage to replace.");
        
        var eleType = fl.getDocumentDOM().selection[0].elementType;
        if ("text" != eleType) return void alert("You must select A Text Line. \n Your Select "+eleType);
        var oldText = fl.getDocumentDOM().getTextString();
        // ####################################################        
//initialize vars: 
var e_harakat=1;        
var numbers = { ar: "٠١٢٣٤٥٦٧٨٩",  fa: "۰۱۲۳۴۵۶۷۸۹",   en: "0123456789"  };                
var defNumbs="ar";    // "ar":arabic, "fa":farsi, "en":english
var outputNumbers = numbers[defNumbs];
        
var y="";        
var g;
var old="";
var tstr="";
var csr1=csr2=0;    //cursor location
var laIndex=8*48;   //position of laa characters in the unicode string
        
        var left="ٹہےگڤچپـئظشسيبلتنمكطضصثقفغعهخحج";                           //defining letters that can connect from the left
        var right="ٹہےڈڑگڤژچپـئؤرلالآىآةوزظشسيبللأاأتنمكطضصثقفغعهخحجدذلإإۇۆۈ";    //defining letters that can connect from the right

        var harakat="ًٌٍَُِّْ";                         //defining the harakat
        var symbols="ـ.،؟ @#$%^&*-+|\/=~,:";    //defining other symbols
        var unicode=
"ﺁ ﺁ ﺂ ﺂ "+"ﺃ ﺃ ﺄ ﺄ "+"ﺇ ﺇ ﺈ ﺈ "+"ﺍ ﺍ ﺎ ﺎ "+"ﺏ ﺑ ﺒ ﺐ "+"ﺕ ﺗ ﺘ ﺖ "+"ﺙ ﺛ ﺜ ﺚ "+"ﺝ ﺟ ﺠ ﺞ "+"ﺡ ﺣ ﺤ ﺢ "+"ﺥ ﺧ ﺨ ﺦ "+
"ﺩ ﺩ ﺪ ﺪ "+"ﺫ ﺫ ﺬ ﺬ "+"ﺭ ﺭ ﺮ ﺮ "+"ﺯ ﺯ ﺰ ﺰ "+"ﺱ ﺳ ﺴ ﺲ "+"ﺵ ﺷ ﺸ ﺶ "+"ﺹ ﺻ ﺼ ﺺ "+"ﺽ ﺿ ﻀ ﺾ "+"ﻁ ﻃ ﻄ ﻂ "+"ﻅ ﻇ ﻈ ﻆ "+
"ﻉ ﻋ ﻌ ﻊ "+"ﻍ ﻏ ﻐ ﻎ "+"ﻑ ﻓ ﻔ ﻒ "+"ﻕ ﻗ ﻘ ﻖ "+"ﻙ ﻛ ﻜ ﻚ "+"ﻝ ﻟ ﻠ ﻞ "+"ﻡ ﻣ ﻤ ﻢ "+"ﻥ ﻧ ﻨ ﻦ "+"ﻩ ﻫ ﻬ ﻪ "+"ﻭ ﻭ ﻮ ﻮ "+
"ﻱ ﻳ ﻴ ﻲ "+"ﺓ ﺓ ﺔ ﺔ "+"ﺅ ﺅ ﺆ ﺆ "+"ﺉ ﺋ ﺌ ﺊ "+"ﻯ ﻯ ﻰ ﻰ "+"ﭖ ﭘ ﭙ ﭗ "+"ﭺ ﭼ ﭽ ﭻ "+"ﮊ ﮊ ﮋ ﮋ "+"ﭪ ﭬ ﭭ ﭫ "+"ﮒ ﮔ ﮕ ﮓ "+
"ﭦ ﭨ ﭩ ﭧ "+"ﮦ ﮨ ﮩ ﮧ "+"ﮮ ﮰ ﮱ ﮯ "+"ﮈ ﮈ ﮉ ﮉ "+"ﮌ ﮌ ﮍ ﮍ "+"ﯗ ﯗ ﯘ ﯘ "+"ﯙ ﯙ ﯚ ﯚ "+"ﯛ ﯛ ﯜ ﯜ "+
"ﻵ ﻵ ﻶ ﻶ "+"ﻷ ﻷ ﻸ ﻸ "+"ﻹ ﻹ ﻺ ﻺ "+"ﻻ ﻻ ﻼ ﻼ ";      //defining arabic unicode chars (individual, start, middle, end)

        var arabic=
"آ"+"أ"+"إ"+"ا"+"ب"+"ت"+"ث"+"ج"+"ح"+"خ"+
"د"+"ذ"+"ر"+"ز"+"س"+"ش"+"ص"+"ض"+"ط"+"ظ"+
"ع"+"غ"+"ف"+"ق"+"ك"+"ل"+"م"+"ن"+"ه"+"و"+
"ي"+"ة"+"ؤ"+"ئ"+"ى"+"پ"+"چ"+"ژ"+"ڤ"+"گ"+
"ٹ"+"ہ"+"ے"+"ڈ"+"ڑ"+"ۇ"+"ۆ"+"ۈ";
        var notEng=arabic+harakat+"ء،؟";        //defining all arabic letters + harakat + arabic symbols
        var brackets="(){}[]";

        

        y=fl.getDocumentDOM().getTextString();        
        x=y.split("");
        len=x.length;
        fl.getDocumentDOM().setTextString("");
        
    for (g=0;g<len;g++)    //process each letter, submit it to tests and then add it to the output string
        {      //ignoring the harakat
      b = a = 1;
      while (harakat.indexOf(x[g - b]) >= 0)
          b = b + 1;
      while (harakat.indexOf(x[g + a]) >= 0)
          a = a + 1;
      if (g == 0) //determine the position of each letter
      {
          if (right.indexOf(x[a]) >= 0)
              pos = 2;
          else
              pos = 0;
      } else if (g == (len - 1)) {
          if (left.indexOf(x[len - b - 1]) >= 0)
              pos = 6;
          else
              pos = 0;
      } else {
          if (left.indexOf(x[(g - b)]) < 0) {
              if (right.indexOf(x[(g + a)]) < 0)
                  pos = 0;
              else
                  pos = 2;
          } else if (left.indexOf(x[(g - b)]) >= 0) {
              if (right.indexOf(x[(g + a)]) >= 0)
                  pos = 4;
              else
                  pos = 6;
          }
      }
      if (x[g] == "\n") //if new line occurs, save old data in a temp, process new data, then regroup
      {
          
          old = old + fl.getDocumentDOM().getTextString() + "\n";
          fl.getDocumentDOM().setTextString("");
          
      } else if (x[g] == "\r") //if this char is carriage return, skip it.
      {} else if (x[g] == "ء")
          addChar("ﺀ");
      else if (brackets.indexOf(x[g]) >= 0) //if this char is a bracket, reverse it
      {
          asd = brackets.indexOf(x[g]);
          if ((asd % 2) == 0)
              addChar(brackets.charAt(asd + 1));
          else
              addChar(brackets.charAt(asd - 1));
      } else if (arabic.indexOf(x[g]) >= 0) //if the char is an Arabic letter.. convert it to Unicode
      {
          if (x[g] == "ل") //if this letter is (laam)
          { //check if its actually a (laa) combination
              ar_pos = arabic.indexOf(x[g + 1]);
              
              if ((ar_pos >= 0) && (ar_pos < 4)) {
              
                  addChar(unicode.charAt((ar_pos * 8) + pos + laIndex))
                  g = g + 1;
              } else //if its just (laam)
                  addChar(unicode.charAt((arabic.indexOf(x[g]) * 8) + pos));
          } else //if its any arabic letter other than (laam)
              addChar(unicode.charAt((arabic.indexOf(x[g]) * 8) + pos));
      } else if (symbols.indexOf(x[g]) >= 0) //if the char is a symbol, add it
          addChar(x[g]);
      else if (harakat.indexOf(x[g]) >= 0) //if the char is a haraka, and harakat are enabled, add it
      {
          if (e_harakat == 1)
              addChar(x[g]);
          else {}
      } else if (unicode.indexOf(x[g]) >= 0) //if the char is an arabic reversed letter, reverse it back!
      {
          uni_pos = unicode.indexOf(x[g]);
          la_pos = unicode.indexOf(x[g]);
          if (la_pos >= laIndex) //if its a laa combination
              for (temp = 8; temp < 40; temp += 8) //find which laa
          {
              if (la_pos < (temp + laIndex)) {
                  addChar(arabic.charAt((temp / 8) - 1));
                  addChar("ل");
                  temp = 60;
              }
          } else //if its any other letter
              for (temp = 8; temp < (laIndex + 32); temp += 8) {
                  if (uni_pos < temp) {
                      addChar(arabic.charAt((temp / 8) - 1));
                      temp = 1000;
                  }
              }
      } else //if the char is none of the above, then treat it as english text (don't reverse) (english chars + numbers + symbols (as is))
      {
          h = g;
          
          while ((notEng.indexOf(x[h]) < 0) && (unicode.indexOf(x[h]) < 0) && (brackets.indexOf(x[h]) < 0) && (x[h] != undefined)) //if this is an english sentence, or numbers, put it all in one string
          {
              for (var key in numbers) {
                  if (numbers.hasOwnProperty(key)) {
                      mynumb = numbers[key].indexOf(x[h]);
                      if (mynumb >= 0) {
                          x[h] = numbers[defNumbs].charAt(mynumb);
                      }
                  }
              }
              tstr = tstr + x[h];
              h = h + 1;
              
                  temp = h;
              if (x[temp] == "\n")
                  break;
          }
          xstr = tstr.split("");
          r = xstr.length - 1;
          if ((r == 1) && (xstr[1] == " ")) //make sure spaces between arabic and english text display properly
              tstr = " " + xstr[0];
          else {
              while (xstr[r] == " ") {
                  tstr = " " + tstr.substring(0, (tstr.length - 1));
                  r = r - 1;
              }
          }          
          var preText = tstr + fl.getDocumentDOM().getTextString();                     
          fl.getDocumentDOM().setTextString(preText);
          
          tstr = "";
          g = h - 1; //set the loop pointer to the first char after the english text.
      }
      }
        
        //put together the old text and the last sentence
        finalText=old+fl.getDocumentDOM().getTextString();
        fl.getDocumentDOM().setTextString(finalText);
        
         
    };

    function addChar(chr)  //add arabic chars (change to Unicode)
    {    
    var newChar = chr+fl.getDocumentDOM().getTextString();
    fl.getDocumentDOM().setTextString(newChar);
    };
    new e
}();
